<?php
/**
 * Copyright © 2017 MageWorx. All rights reserved.
 * See LICENSE.txt for license details.
 */

namespace FiloBlu\ExtMageWorxSeoRedirects\Controller\Adminhtml\CustomRedirect;


use Magento\Backend\App\Action\Context;
use Magento\Ui\Component\MassAction\Filter;
use MageWorx\SeoRedirects\Model\ResourceModel\Redirect\CustomRedirect\CollectionFactory;
use Magento\Framework\Controller\ResultFactory;

class MassExportCsv extends \Magento\Backend\App\Action
{
    protected $resultRawFactory;
 
    protected $csvWriter;
 
    protected $fileFactory;
 
    protected $directoryList;
 
        /**
     * @var Filter
     */
    protected $filter;

    /**
     * @var CollectionFactory
     */
    protected $collectionFactory;
    
    /**
     * @param Context $context
     * @param Filter $filter
     * @param CollectionFactory $collectionFactory
     */
    public function __construct(Context $context, 
            Filter $filter,
            CollectionFactory $collectionFactory,
             \Magento\Framework\Controller\Result\RawFactory $resultRawFactory,
        \Magento\Framework\App\Response\Http\FileFactory $fileFactory,
        \Magento\Framework\File\Csv $csvWriter,
        \Magento\Framework\App\Filesystem\DirectoryList $directoryList)
    {
        $this->filter = $filter;
        $this->collectionFactory = $collectionFactory;
        $this->csvWriter = $csvWriter;
        $this->resultRawFactory = $resultRawFactory;
        $this->fileFactory = $fileFactory;
        $this->directoryList = $directoryList;
        parent::__construct($context);
    }
    
    public function execute()
    {
        $collection = $this->filter->getCollection($this->collectionFactory->create());

        $data = [];
        $data[] = ['redirect_code','request_entity_type','request_entity_identifier','target_entity_type','target_entity_identifier','store_id'];
        
        foreach ($collection as $item) {
            $data[] = [$item->getData('redirect_code'),
                $item->getData('request_entity_type'),
                $item->getData('request_entity_identifier'),
                $item->getData('target_entity_type'),
                $item->getData('target_entity_identifier'),
                $item->getData('store_id')];
        }

//        $data = [
//            ['column 1','column 2','column 3'],
//            ['row 1','row 1','row 1'],
//            ['row 2','row 2','row 2'],
//        ];
 
        $fileDirectory = \Magento\Framework\App\Filesystem\DirectoryList::MEDIA;
        $fileName = 'custom_redirect_' . time() . '.csv';
        $filePath =  $this->directoryList->getPath($fileDirectory) . "/" . $fileName;
 
        $this->csvWriter
            ->setEnclosure('"')
            ->setDelimiter(',')
            ->saveData($filePath ,$data);
 
        $this->fileFactory->create(
            $fileName,
            [
                'type'  => "filename",
                'value' => $fileName,
                'rm'    => true,
            ],
            \Magento\Framework\App\Filesystem\DirectoryList::MEDIA,
            'text/csv',
            null
        );
 
        $resultRaw = $this->resultRawFactory->create();
 
        return $resultRaw;
        
    }
}
